%error = ForceRequiredAddOn("Weapon_Gun");

if(%error == $Error::AddOn_Disabled)
{
	GunItem.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
	//we don't have the gun, so we're screwed
	error("ERROR: Weapon_OldSchoolRifle - ...What the hell, you don't have the gun enabled!");
	return;
}

AddDamageType("OldSchoolSniper", '<bitmap:add-ons/Weapon_OldSchoolRifle/CI_sniper> %1', '%2 <bitmap:add-ons/Weapon_OldSchoolRifle/CI_sniper> %1', 0.2, 1);

datablock PlayerData(oldschoolrifleArmor : PlayerStandardArmor)
{
	firstPersonOnly=1;

   runForce = 10 * 180;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 3;
   maxBackwardSpeed = 3;
   maxSideSpeed = 3;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 8 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;


	uiName = "";
	showEnergyBar = false;

   runSurfaceAngle  = 45;
   jumpSurfaceAngle = 45;
};

datablock ParticleData(altRifleFireParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

	colors[0]     = "0.9 0.9 0 0.3";
	colors[1]     = "1 0.5 0.2 0.5";
	colors[2]     = "1 0.5 0.2 0.0";

	sizes[0]      = 3.25;
   sizes[1]      = 0.5;
	sizes[2]      = 0.30;

   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(altRifleFireEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 58.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "altRifleFireParticle";
};


// Obnoxious Sound Files
datablock AudioProfile(altRifleReloadSound)
{
	filename    = "./reload1.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(altRifleScopeSound)
{
	filename    = "./sniper_scope.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(altRifleScopeBackSound)
{
	filename    = "./sniper_scopeback.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(altRifleBoltSound)
{
	filename    = "./boltpull.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(altRifleFireSound)
{
	filename    = "./sniper_fire.3.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(altRifleConnectSound)
{
	filename    = "./sniper_connect.2.wav";
	description = AudioClose3d;
	preload = true;
};

// Emitters / Particles
datablock ParticleData(altRifleExplosionParticle)
{
	dragCoefficient      = 6;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 2700;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "0.13 0.04 0.02 0.8";
	colors[1]			= "0.13 0.04 0.02 0.0";
	sizes[0]			= 2.25;
	sizes[1]			= 4.25;

	useInvAlpha = true;
};

datablock ParticleEmitterData(altRifleExplosionEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 2;
	velocityVariance	= 1.0;
	ejectionOffset  	= 0.0;
	thetaMin			= 89;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "altRifleExplosionParticle";
};

datablock ParticleData(altRifleExplosionRingParticle)
{
	dragCoefficient			= 8;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.2;
	constantAcceleration	= 0.0;
	lifetimeMS				= 20;
	lifetimeVarianceMS		= 0;
	textureName				= "base/data/particles/star1";
	spinSpeed				= 0.0;
	spinRandomMin			= 0.0;
	spinRandomMax			= 0.0;
	colors[0]				= "1 1 0.0 0.9";
	colors[1]				= "0.9 0.0 0.0 0.0";
	sizes[0]				= 2;
	sizes[1]				= 3;

	useInvAlpha				= false;
};

datablock ParticleEmitterData(altRifleExplosionRingEmitter)
{
	lifeTimeMS			= 50;
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0;
	velocityVariance	= 0.0;
	ejectionOffset		= 0.0;
	thetaMin			= 89;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "altRifleExplosionRingParticle";
};

datablock ParticleData(altRifleExplosionRing2Particle)
{
	dragCoefficient			= 2;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.2;
	constantAcceleration	= 0.0;
	lifetimeMS				= 1240;
	lifetimeVarianceMS		= 1230;
	textureName				= "base/data/particles/dot";
	spinSpeed				= 0.0;
	spinRandomMin			= 0.0;
	spinRandomMax			= 0.0;
	colors[0]				= "1 1 0.0 0.9";
	colors[1]				= "1 1 1.0 0.0";
	sizes[0]				= 0.1;
	sizes[1]				= 0.2;
	useInvAlpha				= false;
};

datablock ParticleEmitterData(altRifleExplosionRing2Emitter)
{
	lifeTimeMS			= 100;
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 3;
	velocityVariance	= 3.0;
	ejectionOffset		= 1.0;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= "altRifleExplosionRing2Particle";
};

// Explosion, Projectile, Item, and Image
datablock ExplosionData(altRifleExplosion)
{
	soundProfile		= altRifleConnectSound;
	
	lifeTimeMS			= 150;
	
	particleEmitter		= altRifleExplosionEmitter;
	particleDensity		= 5;
	particleRadius		= 0.2;
	
	emitter[0]			= altRifleExplosionRingEmitter;
	emitter[1]			= altRifleExplosionRing2Emitter;
	
	faceViewer			= true;
	explosionScale		= "1 1 1";
	
	shakeCamera			= false;
	camShakeFreq		= "10.0 11.0 10.0";
	camShakeAmp			= "1.0 1.0 1.0";
	camShakeDuration	= 0.5;
	camShakeRadius		= 10.0;
	
	lightStartRadius	= 1;
	lightEndRadius		= 0;
	lightStartColor		= "0.3 0.6 0.7";
	lightEndColor		= "0 0 0";

	impulseRadius		= 2;
	impulseForce		= 7500;
};

datablock ProjectileData(altRifleProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";

	directDamage					= 60;
	directDamageType				= $DamageType::OldSchoolSniper;
	radiusDamageType				= $DamageType::OldSchoolSniper;

	brickExplosionRadius			= 0;
	brickExplosionImpact			= true;
	brickExplosionForce				= 10;
	brickExplosionMaxVolume			= 1;
	brickExplosionMaxVolumeFloating	= 2;

	impactImpulse					= 1900;
	verticalImpulse					= 400;
	explosion						= altRifleExplosion;

	muzzleVelocity					= 200;
	velInheritFactor				= 1;

	armingDelay						= 00;
	lifetime						= 9000;
	fadeDelay						= 8500;
	bounceElasticity				= 0.5;
	bounceFriction					= 0.20;
	isBallistic						= false;
	gravityMod						= 0.1;

	hasLight						= false;
	lightRadius						= 3.0;
	lightColor						= "0 0 0.5";
};

datablock ItemData(altRifleItem)
{
	category	= "Weapon";
	className	= "Weapon";
	
	shapeFile	= "./scopeableOSR.dts";
	rotate		= false;
	mass		= 1;
	density		= 0.2;
	elasticity	= 0.2;
	friction	= 0.6;
	emap		= true;
	
	uiName		= "Old School Rifle";
	iconName	= "./icon_osrnew1";
	
	image		= altRifleImage;
	canDrop		= true;
};

datablock ShapeBaseImageData(altRifleImage)
{
	shapeFile					= "./scopeableOSR.dts";
	emap						= true;

	mountPoint					= 0;
	offset						= "0 0 0";
	eyeOffset					= "0.4 0.9 -0.4";
	rotation					= eulerToMatrix( "0 0 0" );

	correctMuzzleVector			= true;
	className					= "WeaponImage";
	item						= BowItem;
	ammo						= " ";

   projectile = altRifleProjectile;
   projectileType = Projectile;

	casing						= gunShellDebris;
	shellExitDir				= "1.0 -0.3 1.0";
	shellExitOffset				= "0 0 0.8";
	shellExitVariance			= 15.0;	
	shellVelocity				= 7.0;

	melee						= false;
	armReady					= true;
	minShotTime					= 1000;

	doColorShift				= false;
	colorShiftColor				= altRifleItem.colorShiftColor;
	
	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "ReadyUp";
	stateSequence[0]			= "Activate";
	stateTransitionOnTriggerDown[0]	= "ReadyUp";

	stateName[1]				= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;
	stateSequence[1]				= "Ready";

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2]	= "FirePhase2";
	stateTimeoutValue[2]		= 0.01;
	stateAllowImageChange[2]	= false;
	stateSequence[2]			= "Fire";
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]				= altrifleFireEmitter;
	stateEmitterTime[2]			= 0.01;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= altRifleFireSound;

	stateName[3]				= "Smoke";
	stateTimeoutValue[3]		= 0.60;
	stateSequence[3]			= "Reload";
	stateTransitionOnTimeout[3]	= "Reload";
	stateEjectShell[3]			= true;
	stateSound[3]				= altRifleBoltSound;

	stateName[4]				= "Reload";
	stateTimeoutValue[4]		= 0.80;
	stateTransitionOnTimeout[4]	= "Ready";
	stateSound[4]				= altRifleReloadSound;

	stateName[5]				= "FirePhase2";
	stateTimeoutValue[5]		= 0.10;
	stateTransitionOnTimeout[5]	= "Pause";
	stateEmitterNode[5]			= "muzzleNode";

	stateName[6]				= "ReadyUp";
	stateTimeoutValue[6]		= 0.40;
	stateSequence[6]			= "Reload";
	stateTransitionOnTimeout[6]	= "Reload";
	stateSound[6]				= altRifleBoltSound;

	stateName[7]				= "Pause";
	stateTimeoutValue[7]		= 0.40;
	stateTransitionOnTimeout[7]	= "Smoke";
	oldSchoolRifle = true;
};

datablock ShapeBaseImageData(altRifleImageScoped)
{
	raycastWeaponRange			= 1000;				
	raycastWeaponTargets		= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
	raycastDirectDamage			= 80;
	raycastDirectDamageType		= $DamageType::OldSchoolSniper;		
	raycastExplosionProjectile	= altRifleProjectile;			
	raycastExplosionSound		= altRifleConnectSound;

	shapeFile					= "./scopeableOSR.dts";
	emap						= true;

	mountPoint					= 0;
	offset						= "0 0 0";
	eyeoffset 					= "0.0 -0.55 -0.264";
	rotation					= eulerToMatrix( "0 0 0" );

	correctMuzzleVector			= true;
	className					= "WeaponImage";
	item						= BowItem;
	ammo						= " ";

	casing						= gunShellDebris;
	shellExitDir				= "1.0 -0.3 1.0";
	shellExitOffset				= "0 0 0.8";
	shellExitVariance			= 15.0;	
	shellVelocity				= 7.0;

	melee						= false;
	armReady					= true;
	minShotTime					= 1600;

	doColorShift				= false;
	colorShiftColor				= altRifleItem.colorShiftColor;
	
	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "ReadyUp";
	stateSequence[0]			= "Activate";
	stateTransitionOnTriggerDown[0]	= "ReadyUp";

	stateName[1]				= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]	= true;

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2]	= "FirePhase2";
	stateTimeoutValue[2]		= 0.01;
	stateFire[2]				= true;
	stateAllowImageChange[2]	= false;
	stateSequence[2]			= "Fire";
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]				= altrifleFireEmitter;
	stateEmitterTime[2]			= 0.01;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= altRifleFireSound;

	stateName[3]				= "Smoke";
	stateTimeoutValue[3]		= 0.60;
	stateSequence[3]			= "Reload";
	stateTransitionOnTimeout[3]	= "Reload";
	stateEjectShell[3]			= true;
	stateSound[3]				= altRifleBoltSound;

	stateName[4]				= "Reload";
	stateTimeoutValue[4]		= 0.80;
	stateTransitionOnTimeout[4]	= "Ready";
	stateSound[4]				= altRifleReloadSound;

	stateName[5]				= "FirePhase2";
	stateTimeoutValue[5]		= 0.10;
	stateTransitionOnTimeout[5]	= "Pause";
	stateEmitterNode[5]			= "muzzleNode";

	stateName[6]				= "ReadyUp";
	stateTimeoutValue[6]		= 0.40;
	stateSequence[6]			= "Reload";
	stateTransitionOnTimeout[6]	= "Reload";
	stateSound[6]				= altRifleBoltSound;

	stateName[7]				= "Pause";
	stateTimeoutValue[7]		= 0.40;
	stateTransitionOnTimeout[7]	= "Smoke";
	//eh
	oldSchoolRifle = true;
};

// Code
// iban's fantastic pierce script, also range fixes
function altRifleImageScoped::onFire(%this, %obj, %slot)
{
	if(%this.raycastWeaponRange > 0)
	{
		// Directional Math
		%fvec		= %obj.getForwardVector();
		%fX			= getWord(%fvec,0);
		%fY			= getWord(%fvec,1);
		
		%evec		= %obj.getEyeVector();
		%eX			= getWord(%evec,0);
		%eY			= getWord(%evec,1);
		%eZ			= getWord(%evec,2);
		
		%eXY		= mSqrt((%eX * %eX) + (%eY * %eY));
		%aimVec		= (%fX * %eXY) SPC (%fY * %eXY) SPC %eZ;
		
		// Range
		%range		= %this.raycastWeaponRange * getWord(%obj.getScale(), 2);
		
		if(%range >= 100)
		{
			%rangeRem = %range - 100;
			%range = 100;
		}
		
		// Raycast Parameters
		%start		= %obj.getEyePoint();
		%end[0]		= vectorAdd(%start, vectorScale(%aimVec, %range)); // [0] required for loop
		%targets	= %this.raycastWeaponTargets;
		
		// Raycasting
		%ray		= ContainerRayCast(%start, %end[0], %targets, %obj);
		%col		= getWord(%ray, 0);
		
		if(isObject(%col))
		{
			%pos	= posFromRaycast(%ray);
			%normal	= normalFromRaycast(%ray);
			%end[0]	= %pos;
			%colclass	= %col.getClassName();
			%objsHit++;
			
			%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
			
			if(%colclass $= "Player" || %colclass $= "AIPlayer")
			{
				if(%col.getState() $= "Dead")
				{
					%objsKilled++;
				}
			}
		}
		
		if(%rangeRem > 0)
		{
			for(%a = 1; %a <= 10 && %rangeRem > 0; %a++)
			{
				%range		= %rangeRem;
				
				if(%range >= 100)
				{
					%rangeRem = %range - 100;
					%range = 100;
				}
				
				%start[%a]	= %end[%a - 1];
				%end[%a]	= vectorAdd(%start[%a], vectorScale(%aimVec, %range)); 
				
				%ray		= ContainerRayCast(%start[%a], %end[%a], %targets, %obj);
				%col		= getWord(%ray, 0);
				
				if(isObject(%col))
				{
					%pos		= posFromRaycast(%ray);
					%normal		= normalFromRaycast(%ray);
					%end[%a]	= %pos;
					%colclass	= %col.getClassName();
					%objsHit++;
					
					%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
					
					if(%colclass $= "Player" || %colclass $= "AIPlayer")
					{
						if(%col.getState() $= "Dead")
						{
							%objsKilled++;
						}
					}
					
					if(%objsHit >= 4)
					{
						break;
					}
				}
			}
		}
		
		if(%objsKilled >= 2 && isObject(%client = %obj.client))
		{
			commandToClient(%client, 'bottomPrint', "<color:00ff00>Nice Shot! <color:ffffff>" @ %objsKilled @ " birds, one stone.", 5);
		}
	}
	else
	{
		return Parent::onFire(%this, %obj, %slot);
	}
}

function altRifleImageScoped::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %objsHit)
{ 
	if(%this.raycastDirectDamage > 0 && %col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
		if(miniGameCanDamage(%obj, %col) == 1 && !%col.getDatablock().indestructable)
		{
			if(%this.raycastDirectDamageType)
			{
				%damageType = %this.raycastDirectDamageType;
			}
			else
			{
				%damageType = $DamageType::Direct;
			}
			
			%scale			= %obj.getScale();
			%scaleFactor	= (getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3;
			%damFloat		= mClampF(%this.raycastDirectDamage, -100, 100);
			%directDamage	= (%damFloat * %scaleFactor) / %objsHit;
			
			%col.damage(%obj, %pos, %directDamage, %damageType);
		}
	}
	
	if(isObject(%this.raycastExplosionProjectile))
	{
		%scale			= %obj.getScale();
		%scaleFactor	= ((getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3) / %objsHit;
		
		%p = new Projectile()
		{
			dataBlock		= %this.raycastExplosionProjectile;
			initialPosition	= %pos;
			initialVelocity	= %normal;
			sourceObject	= %obj;
			client			= %obj.client;
			sourceSlot		= 0;
			originPoint		= %pos;
		};
		
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		%p.explode();
	}
	
	if(isObject(%this.raycastExplosionSound))
	{
		serverplay3d(%this.raycastExplosionSound, %pos);
	}
}
package OldSchoolRifle

{

          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "AltRifleImage" || %player.getMountedImage(0).getName() $= "AltRifleImageScoped") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "AltRifleImage":

                                                %player.mountImage(AltRifleImageScoped,0);

                                        case "AltRifleImageScoped":

                                                %player.mountImage(AltRifleImage,0);

                                }

                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }

};
ActivatePackage(OldSchoolRifle);

function altRifleImageScoped::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);	
	serverPlay3D(altRifleScopeSound,%obj.getTransform());

	%client = %obj.client;
	%client.player.setDataBlock("oldschoolrifleArmor"); 

}

function altRifleImageScoped::onUnMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);	
	serverPlay3D(altRifleScopeBackSound,%obj.getTransform());


	%client = %obj.client;
		if(!isObject(%client.minigame))
		{
			%client.player.setDataBlock("PlayerStandardArmor");
		}else{
			%client.player.setdatablock(%client.minigame.playerDatablock);
		}
}

function altRifleImage::onFire(%this,%obj,%slot)
{
	%projectile = %this.projectile;
	%spread = 0.0008;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}